#include "Exceptions.h"
#include "BinaryAdapterFormat.h"
#include "BinaryAdapterClassifier.h"

using namespace phylum;

Format* BinaryAdapterClassifier::toRaw(const Format* fmt)
{
  const BinaryAdapterFormat* adapter = dynamic_cast<const BinaryAdapterFormat*>(fmt);
  if(adapter == NULL)
  {
    throw UnsupportedFormatException("Invalid format specified for BinaryAdapterClassifier; BinaryAdapterClassifier only accepts BinaryAdapterFormat for conversion to RawFormat");
  }

  RawFormat* raw = NULL;

  size_t total = adapter->getDataSize();
  if(total > 0)
  {
    raw = new RawFormat(total, this);
    adapter->fill(raw->getBuffer(), total);
    raw->setDataSize(total);
  }

  return raw;
}

Format* BinaryAdapterClassifier::fromRaw(const Format* fmt)
{
  throw NotImplementedException("BinaryAdapterClassifier::fromRaw is not implemented");
}
