#ifndef CLASSIFIER_H
#define CLASSIFIER_H

#include "Creator.h"

class Format;

// Abstract class defining an object responsible for determing the type
// of a format received from a source.  Required for sources capable of
// processing more than one format.  Analyzes contents of message and returns
// an integer value unique to the data source.
class Classifier : public Creator
{
public:
  virtual ~Classifier() { }

  virtual Format* toRaw(const Format* fmt) = 0;

  virtual Format* fromRaw(const Format* fmt) = 0;
};

#endif
