#ifndef DISPATCHER_H
#define DISPATCHER_H

class Format;
class Source;

//Delegate for a single source
class Delegate
{
public:
  virtual ~Delegate() { }

  virtual void dispatch(Format* fmt) = 0;

  virtual void run(size_t limit, size_t max_num_live_pipelines) = 0;
};


//Dispatch data through delegate associated with the specified source
class Dispatcher
{
public:
  virtual ~Dispatcher() { }

  virtual void dispatch(Source* src, Format* fmt) = 0;
};

#endif // DISPATCHER_H
