#include "FormatGroup.h"
#include "FormatGroupDecomposer.h"

POOL_DEFINE(FormatGroup, 1024)

FormatGroup::FormatGroup(const FormatGroup& copy, Creator* creator)
: Format(copy, creator)
{
  for(Group::const_iterator iter = copy.group_.begin(); iter != copy.group_.end(); ++iter)
  {
    group_.push_back((*iter)->clone(creator));
  }
}

void FormatGroup::removeFormat(size_t pos)
{
  Group::iterator iter = group_.begin();
  std::advance(iter, pos);
  group_.erase(iter);
}

/*
#include "FormatGroup.h"

template <typename Container>
FormatGroup<Container>::FormatGroup(const FormatGroup& copy, Creator* creator)
: Format(copy, creator)
{
  for(typename Group::const_iterator iter = copy.group_.begin(); iter != copy.group_.end(); ++iter)
  {
    group_.push_back((*iter)->clone(creator));
  }
}

template <typename Container>
void FormatGroup<Container>::removeFormat(size_t pos)
{
  typename Group::iterator iter = group_.begin();
  std::advance(iter, pos);
  group_.erase(iter);
}

template <typename Container>
Format* FormatGroup<Container>::getFormat(size_t pos) const
{
  return group_[pos];
}


template <>
Format* FormatGroup<FormatGroupListContainer>::getFormat(size_t pos) const
{
  Group::const_iterator iter = group_.begin();
  std::advance(iter, pos);
  return *iter;
}
*/
