#ifndef FORMATGROUPDECOMPOSER_H
#define FORMATGROUPDECOMPOSER_H

#include "FormatDecomposer.h"
#include "FormatGroup.h"
#include "Exceptions.h"

class FormatGroupDecomposer : public FormatDecomposer
{
public:
  virtual ~FormatGroupDecomposer() { }

  // Decompose the subformats contained by a composite format to a set of individual formats
  // The individual formats must be copies of the original
  virtual void decompose(const Format* format, ConstFormatVisitor& visitor)
  {
    const FormatGroup* group = dynamic_cast<const FormatGroup*>(format);
    if(group == NULL)
    {
      throw UnsupportedFormatException("Invalid format specified for FormatGroupDecomposer; FormatGroupDecomposer only accepts FormatGroup for conversion to Format");
    }

    for(size_t i = 0; i < group->getNumFormats(); i++)
    {
      visitor.visit(group->getFormat(i));
    }
  }
};

#endif // FORMATGROUPDECOMPOSER_H
