#ifndef RAWDATAGRAMFORMAT_H
#define RAWDATAGRAMFORMAT_H

#include <string>
#include "PoolAllocator.h"
#include "RawFormat.h"

class RawDatagramFormat : public RawFormat
{
protected:
  std::string ipaddr_;
  unsigned short port_;
public:
  RawDatagramFormat(size_t size, Creator* creator) : RawFormat(size, creator) { }

  // Copy Constructor
  RawDatagramFormat(const RawDatagramFormat& copy, Creator* creator) : RawFormat(copy, creator), ipaddr_(copy.ipaddr_), port_(copy.port_) { }

  RawDatagramFormat* clone(Creator* creator) const { return new RawDatagramFormat(*this, creator); }

  POOL_DECLARE(RawDatagramFormat)

  unsigned short getPort() const { return port_; }

  void setPort(unsigned short port) { port_ = port; }

  std::string getAddress() const { return ipaddr_; }

  void setAddress(const std::string& ipaddr) { ipaddr_ = ipaddr; }
};

#endif // RAWDATAGRAMFORMAT_H
