#ifndef TEXTLINEFORMAT_H
#define TEXTLINEFORMAT_H

#include <string>
#include "PoolAllocator.h"
#include "Format.h"

class TextLineFormat : public Format
{
protected:
  std::string line_;

public:
  TextLineFormat(Creator* creator) : Format(0, creator) { }

  TextLineFormat(const std::string& line, Creator* creator) : Format(1, creator), line_(line) { }

  TextLineFormat(const TextLineFormat& copy, Creator* creator) : Format(copy, creator), line_(copy.line_) { }

  TextLineFormat* clone(Creator* creator) const { return new TextLineFormat(*this, creator); }

  POOL_DECLARE(TextLineFormat)

  std::string getLine() const { return line_; }

  void setLine(const std::string& line)
  {
    line_ = line;
  }
};

#endif // TEXTLINEFORMAT_H
