#ifndef TEXTLINESDECOMPOSER_H
#define TEXTLINESDECOMPOSER_H

#include "TextLinesFormat.h"
#include "TextLineFormat.h"
#include "FormatDecomposer.h"
#include "Exceptions.h"

class TextLinesDecomposer : public FormatDecomposer
{
public:
  virtual ~TextLinesDecomposer() { }

  virtual void decompose(const Format* format, ConstFormatVisitor& visitor)
  {
    const TextLinesFormat* lines = dynamic_cast<const TextLinesFormat*>(format);
    if(lines == NULL)
    {
      throw UnsupportedFormatException("Invalid format specified for TextLinesDecomposer; TextLinesDecomposer only accepts TextLinesFormat for conversion to TextLineFormat");
    }

    TextLineFormat line(this);
    for(size_t i = 0; i < lines->getNumLines(); i++)
    {
      line.setLine(lines->getLine(i));
      line.setSource(lines->getSource());
      visitor.visit(&line);
    }
  }
};

#endif // TEXTLINESDECOMPOSER_H
